<?php

function create_dl_index($parent = 0)
{
	global $db, $phpEx, $board_config, $tree_dl, $userdata, $dl_auth;

	$sql = "SELECT * FROM " . DL_CAT_TABLE . " 
		WHERE parent = $parent 
		ORDER BY sort";

	if ($result = $db->sql_query($sql))
	{
		while ( $row = $db->sql_fetchrow( $result ) )
		{ 
			$cat_id =  $row['id'];

			if ($row['auth_view'] || $dl_auth[$cat_id]['auth_view'] || $userdata['user_level'] == ADMIN)
			{
				$cat_desc =  $row['description'];
				$cat_name = $row['cat_name'];
				$cat_bbcode_uid = $row['bbcode_uid'];
				$cat_view = append_sid("downloads.$phpEx?cat=$cat_id");

				$cat_desc = ( $board_config['allow_html'] ) ? make_clickable($cat_desc) : preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $cat_desc);
				$cat_desc = ( $board_config['allow_bbcode'] && $cat_bbcode_uid != '' ) ? bbencode_second_pass($cat_desc, $cat_bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $cat_desc);
				$cat_desc = ( $board_config['allow_smilies'] ) ? smilies_pass($cat_desc) : $cat_desc;

				$cat_name = ( $board_config['allow_html'] ) ? make_clickable($cat_name) : preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $cat_name);
				$cat_name = ( $board_config['allow_bbcode'] && $cat_bbcode_uid != '' ) ? bbencode_second_pass($cat_name, $cat_bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $cat_name);
				$cat_name = ( $board_config['allow_smilies'] ) ? smilies_pass($cat_name) : $cat_name;

				$tree_dl[$cat_id]['description'] = $cat_desc;
				$tree_dl[$cat_id]['cat_name'] = $cat_name;
				$tree_dl[$cat_id]['nav_path'] = $cat_view;
				$tree_dl[$cat_id]['cat_path'] = $row['path'];

				$tree_dl[$cat_id]['sublevel'] = '<span class="gensmall">'.get_sublevel($cat_id).'</span>';

				$tree_dl[$cat_id]['auth_view'] = $row['auth_view'];
				$tree_dl[$cat_id]['auth_dl'] = $row['auth_dl'];
				$tree_dl[$cat_id]['auth_up'] = $row['auth_up'];
				$tree_dl[$cat_id]['auth_mod'] = $row['auth_mod'];
			}
		}
	}

	return $tree_dl;
}

function create_dl_admin_index($parent = 0, $level = 0)
{
	global $db, $phpEx, $board_config, $tree_dl;

	$sql = "SELECT * FROM " . DL_CAT_TABLE . " 
		WHERE parent = $parent 
		ORDER BY sort";

	if ($result = $db->sql_query($sql))
	{
		while ( $row = $db->sql_fetchrow( $result ) )
		{ 
			$cat_id =  $row['id'];
			$cat_desc =  $row['description'];
			$cat_name = $row['cat_name'];
			$cat_bbcode_uid = $row['bbcode_uid'];
			$cat_view = append_sid("downloads.$phpEx?cat=$cat_id");

			$cat_desc = ( $board_config['allow_html'] ) ? make_clickable($cat_desc) : preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $cat_desc);
			$cat_desc = ( $board_config['allow_bbcode'] && $cat_bbcode_uid != '' ) ? bbencode_second_pass($cat_desc, $cat_bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $cat_desc);
			$cat_desc = ( $board_config['allow_smilies'] ) ? smilies_pass($cat_desc) : $cat_desc;

			$cat_name = ( $board_config['allow_html'] ) ? make_clickable($cat_name) : preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $cat_name);
			$cat_name = ( $board_config['allow_bbcode'] && $cat_bbcode_uid != '' ) ? bbencode_second_pass($cat_name, $cat_bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $cat_name);
			$cat_name = ( $board_config['allow_smilies'] ) ? smilies_pass($cat_name) : $cat_name;

			$seperator = '';
			for ($i = 0; $i < $level; $i++)
			{
				$seperator .= ($row['parent'] != 0) ? '&nbsp;&nbsp;|___&nbsp;' : '';
			}

			$tree_dl[$cat_id]['description'] = $cat_desc;
			$tree_dl[$cat_id]['cat_name'] = $seperator.'&nbsp;'.$cat_name;
			$tree_dl[$cat_id]['nav_path'] = $cat_view;
			$tree_dl[$cat_id]['cat_path'] = $row['path'];

			$tree_dl[$cat_id]['auth_view'] = $row['auth_view'];
			$tree_dl[$cat_id]['auth_dl'] = $row['auth_dl'];
			$tree_dl[$cat_id]['auth_up'] = $row['auth_up'];
			$tree_dl[$cat_id]['auth_mod'] = $row['auth_mod'];

			$level++;
			create_dl_admin_index($cat_id, $level);
			$level--;
		}
	}

	return $tree_dl;
}

function get_sublevel($parent = 0)
{
	global $db, $phpEx, $board_config, $images, $dl_auth, $userdata;

	$sql = "SELECT * FROM " . DL_CAT_TABLE . " 
		WHERE parent = $parent 
		ORDER BY sort";

	if ($result = $db->sql_query($sql))
	{
		$sublevel = '';
		while ( $row = $db->sql_fetchrow( $result ) )
		{ 
			$subcat_id = $row['id'];

			if ($row['auth_view'] || $dl_auth[$subcat_id]['auth_view'] || $userdata['user_level'] == ADMIN)
			{
				$cat_name = $row['cat_name'];
				$cat_bbcode_uid = $row['bbcode_uid'];

				$cat_seperator = '<br />&nbsp;&raquo;&nbsp;';

				$cat_name = ( $board_config['allow_html'] ) ? make_clickable($cat_name) : preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $cat_name);
				$cat_name = ( $board_config['allow_bbcode'] && $cat_bbcode_uid != '' ) ? bbencode_second_pass($cat_name, $cat_bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $cat_name);
				$cat_name = ( $board_config['allow_smilies'] ) ? smilies_pass($cat_name) : $cat_name;

				$cat_name = '<a href="'.append_sid("downloads.$phpEx?cat=$subcat_id").'" class="gensmall">'.$cat_name.'</a>';

				$sublevel .= $cat_seperator . $cat_name;
			}
		}
	}

	return $sublevel;
}

function create_dl_nav($parent)
{
	global $db, $phpbb_root_path, $phpEx, $board_config, $path_dl_array, $path_dl_array2;

	$sql = "SELECT * FROM " . DL_CAT_TABLE . " 
		       WHERE id = $parent";

	if ( !( $result = $db->sql_query( $sql ) ) )
	{
		message_die( GENERAL_ERROR, "Could not obtain category data", '', __LINE__, __FILE__, $sql );
	}

	$row = $db->sql_fetchrow($result);

	$temp_url = append_sid("downloads.$phpEx?cat=".$row['id']);
	$temp_title = $row['cat_name'];
	$cat_bbcode_uid = $row['bbcode_uid'];

	$temp_title = ( $board_config['allow_html'] ) ? make_clickable($temp_title) : preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $temp_title);
	$temp_title = ( $board_config['allow_bbcode'] && $cat_bbcode_uid != '' ) ? bbencode_second_pass($temp_title, $cat_bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $temp_title);
	$temp_title = ( $board_config['allow_smilies'] ) ? smilies_pass($temp_title) : $temp_title;

	$path_dl_array[] .= '&nbsp;&raquo;&nbsp;<a href="' . $temp_url . '" class="nav">' . $temp_title . '</a>';

	if ($row['parent'] != 0)
	{
		create_dl_nav($row['parent']);
	}

	$path_dl_array2 = array_reverse($path_dl_array);

	$i = 0;
	$path_dl = '';

	while ($i <= count($path_dl_array2))
	{
		$path_dl .= $path_dl_array2[$i];
		$i++;
	}

	return $path_dl;
}

function make_dl_jumpbox($cur, $parent = 0, $level = 0)
{
	global $db, $dl_auth, $userdata; 

	$sql = "SELECT * FROM " . DL_CAT_TABLE . "
		WHERE parent = $parent
		ORDER BY sort ASC";
	if ($result = $db->sql_query($sql))
	{
		while ($row = $db->sql_fetchrow($result))
		{		
			$cat_id = $row['id'];

			if ($row['auth_view'] || $dl_auth[$cat_id]['auth_view'] || $userdata['user_level'] == ADMIN)
			{
				$cat_bbcode_uid = $row['bbcode_uid'];

				$cat_name = strip_tags($row['cat_name']);
				$cat_name = preg_replace("/\[.*?:$cat_bbcode_uid:?.*?\]/si", '', $cat_name);
				$cat_name = preg_replace('/\[url\]|\[\/url\]/si', '', $cat_name);
				$cat_name = preg_replace('/\:[0-9a-z\:]+\]/si', ']', $cat_name);

				$cat_name = unprepare_message($cat_name);
				$cat_name = preg_replace('/&#40;/', '(', $cat_name);
				$cat_name = preg_replace('/&#41;/', ')', $cat_name);
				$cat_name = preg_replace('/&#58;/', ':', $cat_name);
				$cat_name = preg_replace('/&#91;/', '[', $cat_name);
				$cat_name = preg_replace('/&#93;/', ']', $cat_name);
				$cat_name = preg_replace('/&#123;/', '{', $cat_name);
				$cat_name = preg_replace('/&#125;/', '}', $cat_name);

				if ($cur == $cat_id)
				{
					$status = 'SELECTED';
				}
				else
				{
					$status = '';
				}

				$seperator = '';

				if ($row['parent'] != 0)
				{
					for($i = 0; $i < $level; $i++)
					{
						$seperator .= '&nbsp;&nbsp;|';
					}
					$seperator .= '___&nbsp;';
				}

				$catlist .= "<option value=\"$cat_id\" $status>$seperator". $cat_name . "</option>\n";
				$level++;
				$catlist .= make_dl_jumpbox($cur, $cat_id, $level);
				$level--;
			}
		}
	}

	return $catlist;
}

function create_dl_overview_index($parent = 0, $level = 0)
{
	global $db, $phpEx, $board_config, $tree_dl, $dl_auth, $userdata;

	$sql = "SELECT * FROM " . DL_CAT_TABLE . " 
		WHERE parent = $parent 
		ORDER BY sort";

	if ($result = $db->sql_query($sql))
	{
		while ( $row = $db->sql_fetchrow( $result ) )
		{ 
			$cat_id =  $row['id'];

			if ($row['auth_view'] || $dl_auth[$cat_id]['auth_view'] || $userdata['user_level'] == ADMIN)
			{
				$cat_desc =  $row['description'];
				$cat_name = $row['cat_name'];
				$cat_bbcode_uid = $row['bbcode_uid'];
				$cat_view = append_sid("downloads.$phpEx?cat=$cat_id");

				$cat_desc = ( $board_config['allow_html'] ) ? make_clickable($cat_desc) : preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $cat_desc);
				$cat_desc = ( $board_config['allow_bbcode'] && $cat_bbcode_uid != '' ) ? bbencode_second_pass($cat_desc, $cat_bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $cat_desc);
				$cat_desc = ( $board_config['allow_smilies'] ) ? smilies_pass($cat_desc) : $cat_desc;

				$cat_name = ( $board_config['allow_html'] ) ? make_clickable($cat_name) : preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $cat_name);
				$cat_name = ( $board_config['allow_bbcode'] && $cat_bbcode_uid != '' ) ? bbencode_second_pass($cat_name, $cat_bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $cat_name);
				$cat_name = ( $board_config['allow_smilies'] ) ? smilies_pass($cat_name) : $cat_name;

				$tree_dl[$cat_id]['description'] = $cat_desc;
				$tree_dl[$cat_id]['cat_name'] = $cat_name;
				$tree_dl[$cat_id]['nav_path'] = $cat_view;
				$tree_dl[$cat_id]['cat_path'] = $row['path'];

				$tree_dl[$cat_id]['auth_view'] = $row['auth_view'];
				$tree_dl[$cat_id]['auth_dl'] = $row['auth_dl'];
				$tree_dl[$cat_id]['auth_up'] = $row['auth_up'];
				$tree_dl[$cat_id]['auth_mod'] = $row['auth_mod'];

				$level++;
				create_dl_overview_index($cat_id, $level);
				$level--;
			}
		}
	}

	return $tree_dl;
}

function create_rating_img($rating_points)
{
	global $images;

	return '<img src="' . $images['Dl_rating_'.ceil($rating_points)] . '" border="0" alt="'.$rating_points.'"/>';
}

function dl_auth($cat = 'all_cats', $groups = TRUE)
{
	global $db, $userdata;

	$auth_perm = $auth_cat = $cat_auth_array = $group_ids = array();

	$sql = "SELECT * FROM " . DL_AUTH_TABLE;
	$sql .= ($cat != 'all_cats') ? ' WHERE cat_id = ' . $cat : '';

	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not read group permissions for downloads', '', __LINE__, __FILE__, $sql);
	}

	if ($db->sql_numrows($result) == 0)
	{
		return array();
	}

	while ($row = $db->sql_fetchrow($result))
	{
		$cat_id = $row['cat_id'];
		$group_id = $row['group_id'];

		$auth_cat[] = $cat_id;

		$auth_perm[$cat_id][$group_id]['auth_view'] = $row['auth_view'];
		$auth_perm[$cat_id][$group_id]['auth_dl'] = $row['auth_dl'];
		$auth_perm[$cat_id][$group_id]['auth_up'] = $row['auth_up'];
		$auth_perm[$cat_id][$group_id]['auth_mod'] = $row['auth_mod'];
	}
	$db->sql_freeresult($result);

	if ($groups == TRUE)
	{
		return $auth_perm;
	}

	$auth_cat = array_unique($auth_cat);

	$sql = "SELECT g.group_id FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug
		WHERE g.group_id = ug.group_id
			AND ug.user_id = " . $userdata['user_id'] . "
			AND g.group_single_user <> " . TRUE . "
			AND ug.user_pending <> " . TRUE;
	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not fetch group_ids for user', '', __LINE__, __FILE__, $sql);
	}

	while ($row = $db->sql_fetchrow($result))
	{
		$group_ids[] = $row['group_id'];
	}
	$db->sql_freeresult($result);

	for ($i = 0; $i < count($auth_cat); $i++)
	{
		$auth_view = $auth_dl = $auth_up = $auth_mod = 0;

		for ($j = 0; $j < count($group_ids); $j++)
		{
			$cat = $auth_cat[$i];
			$user_group = $group_ids[$j];

			if ($auth_perm[$cat][$user_group]['auth_view'] == TRUE)
			{
				$auth_view = TRUE;
			}
			if ($auth_perm[$cat][$user_group]['auth_dl'] == TRUE)
			{
				$auth_dl = TRUE;
			}
			if ($auth_perm[$cat][$user_group]['auth_up'] == TRUE)
			{
				$auth_up = TRUE;
			}
			if ($auth_perm[$cat][$user_group]['auth_mod'] == TRUE)
			{
				$auth_mod = TRUE;
			}
		}

		$cat_auth_array[$cat]['auth_view'] = $auth_view;
		$cat_auth_array[$cat]['auth_dl'] = $auth_dl;
		$cat_auth_array[$cat]['auth_up'] = $auth_up;
		$cat_auth_array[$cat]['auth_mod'] = $auth_mod;
	}

	return $cat_auth_array;
}

function set_auto_traffic()
{
	global $userdata, $db, $board_config;

	if ($userdata['user_id'] == ANONYMOUS)
	{
		return;
	}

	$user_auto_traffic_month = create_date('Ym', $userdata['user_dl_update_time'], $userdata['user_timezone']);
	$current_traffic_month = create_date('Ym', time(), $board_config['board_timezone']);

	if ($user_auto_traffic_month < $current_traffic_month)
	{
		$sql = "SELECT max(g.group_dl_auto_traffic) as max_traffic FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug
			WHERE g.group_id = ug.group_id
				AND ug.user_id = " . $userdata['user_id'] . "
				AND g.group_single_user <> " . TRUE . "
				AND ug.user_pending <> " . TRUE;
		if ($result = $db->sql_query($sql))
		{
			while ($row = $db->sql_fetchrow($result))
			{
				$max_group_row = $row['max_traffic'];
			}
		}
		$db->sql_freeresult($result);

		$user_traffic = (intval($max_group_row) != 0) ? $max_group_row : $board_config['user_dl_auto_traffic'];

		if ($user_traffic > $userdata['user_traffic'])
		{
			$sql = "UPDATE " . USERS_TABLE . "
				SET user_traffic = " . $user_traffic . ", user_dl_update_time = " . time() . "
				WHERE user_id = " . $userdata['user_id'];
			$db->sql_query($sql);

			$userdata['user_traffic'] = $user_traffic;
		}
	}
}

function reset_dl_klicks()
{
	global $userdata, $db, $board_config;

	$auto_click_reset_month = create_date('Ym', $board_config['dl_click_reset_time'], $board_config['board_timezone']);
	$current_traffic_month = create_date('Ym', time(), $board_config['board_timezone']);

	if ($auto_click_reset_month < $current_traffic_month)
	{
		$sql = "UPDATE " . DOWNLOADS_TABLE . "
			SET klicks = 0";
		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not reset monthly clicks for downloads', '', __LINE__, __FILE__, $sql);
		}

		$sql = "UPDATE " . DL_CONFIG_TABLE . "
			SET config_value = ".time()."
			WHERE config_name = 'dl_click_reset_time'";
		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not reset monthly clicks for downloads', '', __LINE__, __FILE__, $sql);
		}

	}
}

function get_dl_status($file_size, $file_extern, $file_id, $file_name, $file_free, $file_klicks, $file_traffic, $cat_id)
{
	global $userdata, $board_config, $dl_auth, $index, $images, $lang, $phpEx;

	$status = '';
	$auth_dl = 0;

	if ( $userdata['session_logged_in'] AND $userdata['user_traffic'] > $file_size AND $file_extern == "0")
	{
		$status = '<a href="'.append_sid("load.$phpEx?id=$file_id").'"><img src="' . $images['Dl_yellow'] . '" border="0" alt="' . $lang['Dl_yellow_explain'] . '" title="' . $lang['Dl_yellow_explain'] . '"></a>';
		$file_name = '<a class="gen" href="'.append_sid("load.$phpEx?id=$file_id").'">'.$file_name.'</a>';
		$auth_dl = TRUE;
	}
	else
	{
		$status = '<img src="' . $images['Dl_red'] . '" alt="' . $lang['Dl_red_explain_alt'] . '" title="' . $lang['Dl_red_explain_alt'] . '">';
	}

	if ( $file_extern == "1")
	{
		$status = '<a href="'.append_sid("load.$phpEx?id=$file_id").'"><img src="' . $images['Dl_grey'] . '" border="0" alt="' . $lang['Dl_grey_explain'] . '" title="' . $lang['Dl_grey_explain'] . '"></a>';
		$file_name = '<a class="gen" href="load.' . $phpEx . '?id=' . $file_id . '">'.$lang['Dl_extern'].'</a>';
		$auth_dl = TRUE;
	}

	if ( $file_free == "1")
	{
		$status = '<a href="'.append_sid("load.$phpEx?id=$file_id").'"><img src="' . $images['Dl_green'] . '" border="0" alt="' . $lang['Dl_green_explain'] . '" title="' . $lang['Dl_green_explain'] . '"></a>';
		$file_name = '<a class="gen" href="load.' . $phpEx . '?id=' . $file_id . '">'.$file_name.'</a>';
		$auth_dl = TRUE;
	}

	if ( $userdata['user_posts'] < $board_config['dl_posts'] AND $file_extern == "0" AND $file_free == "0" )
	{
		$status = '<img src="' . $images['Dl_red'] . '" alt="' . $lang['Dl_red_explain_alt'] . '" title="' . $lang['Dl_red_explain_alt'] . '">';
	}

	if (intval($dl_auth[$cat_id]['auth_dl']) == 0 && intval($index[$cat_id]['auth_dl']) == 0 && $userdata['user_level'] != ADMIN)
	{
		$status = '<img src="' . $images['Dl_red'] . '" alt="' . $lang['Dl_red_explain_perm'] . '" title="' . $lang['Dl_red_explain_perm'] . '">';
	}

	if ((($file_klicks * $file_size) >= $file_traffic) AND ($file_traffic > 0))
	{
		$status = '<img src="' . $images['Dl_red'] . '" alt="' . $lang['Dl_red_explain_alt'] . '" title="' . $lang['Dl_red_explain_alt'] . '">';
	}

	if ($board_config['overall_traffic'] - $board_config['remain_traffic'] <= 0)
	{
		$status = '<img src="' . $images['Dl_blue'] . '" alt="' . $lang['Dl_blue_explain'] . '" title="' . $lang['Dl_blue_explain'] . '">';
	}

	return array('status' => $status, 'file_name' => $file_name, 'auth_dl' => $auth_dl);
}
?>