<?php
/***************************************************************************
 *                           search_downloads.php
 *                            -------------------
 *   begin                : Friday, Apr 22, 2005
 *   copyright            : (C) 2005 OXPUS
 *   email                : webmaster@oxpus.de
 *   based on		  : search.php by phpBB Group
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);
include($phpbb_root_path . 'includes/functions_downloads.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_SEARCH);
init_userprefs($userdata);
//
// End session management
//

$dl_auth = array();
$dl_auth = dl_auth('all_cats', 0);
$index = create_dl_overview_index();

set_auto_traffic();
reset_dl_klicks();

//
// Define initial vars
//
if ( isset($HTTP_POST_VARS['search_keywords']) || isset($HTTP_GET_VARS['search_keywords']) )
{
	$search_keywords = ( isset($HTTP_POST_VARS['search_keywords']) ) ? htmlspecialchars($HTTP_POST_VARS['search_keywords']) : htmlspecialchars($HTTP_GET_VARS['search_keywords']);
}
else
{
	$search_keywords = '';
}

if ( isset($HTTP_POST_VARS['search_cat']) || isset($HTTP_GET_VARS['search_cat']) )
{
	$search_cat = ( isset($HTTP_POST_VARS['search_cat']) ) ? intval($HTTP_POST_VARS['search_cat']) : intval($HTTP_GET_VARS['search_cat']);
}
else
{
	$search_cat = '-1';
}

if ( isset($HTTP_POST_VARS['sort_dir']) || isset($HTTP_GET_VARS['sort_dir']) )
{
	if ( isset($HTTP_POST_VARS['sort_dir']) )
	{
		$sort_dir = ( $HTTP_POST_VARS['sort_dir'] == 'DESC' ) ? 'DESC' : 'ASC';
	}

	if ( isset($HTTP_GET_VARS['sort_dir']) )
	{
		$sort_dir = ( $HTTP_GET_VARS['sort_dir'] == 'DESC' ) ? 'DESC' : 'ASC';
	}

}
else
{
	$sort_dir =  'ASC';
}

if ( isset($HTTP_POST_VARS['search_fields']) || isset($HTTP_GET_VARS['search_fields']) )
{
	$search_in_fields = ( isset($HTTP_POST_VARS['search_fields']) ) ? $HTTP_POST_VARS['search_fields'] : $HTTP_GET_VARS['search_fields'];
}
else
{
	$search_in_fields = 'all';
}

$start = ( isset($HTTP_GET_VARS['start']) ) ? intval($HTTP_GET_VARS['start']) : 0;

make_jumpbox('viewforum.'.$phpEx);

$search_fnames = array($lang['All'], $lang['Dl_file_name'], $lang['Dl_file_description'], $lang['Dl_detail']);
$search_fields = array('all', 'file_name', 'description', 'long_desc');

//
// Output the basic page
//
$page_title = $lang['Search'].' '.$lang['Downloads'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

if ($search_keywords != '')
{
	$template->set_filenames(array(
		'body' => 'search_results_downloads.tpl')
	);

	$search_keywords = str_replace(' ', '%', $search_keywords);
	$search_keywords = str_replace('*', '', $search_keywords);
	$search_keywords = str_replace('?', '', $search_keywords);
	$search_keywords = strtolower($search_keywords);

	$sql_cat = ($search_cat == -1) ? '' : ' AND cat = ' . $search_cat;
	$sql_cat_count = ($search_cat == -1) ? '' : ' WHERE cat = ' . $search_cat;

	switch($search_in_fields)
	{
		case 'all':
			$sql_where = " (d.file_name LIKE ('%$search_keywords%')
					OR d.description LIKE ('%$search_keywords%')
					OR d.long_desc LIKE ('%$search_keywords%'))";
			$sql_where_count = " (file_name LIKE ('%$search_keywords%')
					OR description LIKE ('%$search_keywords%')
					OR long_desc LIKE ('%$search_keywords%'))";
			break;
		case 'file_name':
		case 'description':
		case 'long_desc':
			$sql_where = " d.$search_in_fields LIKE ('%$search_keywords%')";
			$sql_where_count = " $search_in_fields LIKE ('%$search_keywords%')";
			break;
		default:
			message_die(GENERAL_ERROR, 'Could not query search for wrong data fields', '', __LINE__, __FILE__, $sql);
	}

	$sql_where_count = (($sql_cat_count == '') ? ' WHERE ' : ' AND ').$sql_where_count;

	$sql = "SELECT id FROM ".DOWNLOADS_TABLE."
		$sql_cat_count
		$sql_where_count";
	if ( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not read downloads data', '', __LINE__, __FILE__, $sql);
	}

	$total_found_dl = $db->sql_numrows($result);
	$db->sql_freeresult($result);

	$pagination = generate_pagination("search_downloads.$phpEx?search_keywords=$search_keywords&search_cat=$search_cat&sort_dir=$sort_dir", $total_found_dl, $board_config['topics_per_page'], $start);

	$template->assign_vars(array(
		'PAGINATION' => $pagination,
		'L_SEARCH_TITLE' => $lang['Download'].' '.$lang['Search'],
		'L_STATUS' => $lang['Dl_info'],
		'L_CATEGORY' => $lang['Categorie'],
		'L_DESCRIPTION' => $lang['Dl_file_description'],
		'L_FILENAME' => $lang['Dl_file_name'],
		'L_LONG_DESC' => $lang['Dl_detail'],
		'NAV1' => '<a href="'.append_sid("downloads.$phpEx") . '" class="nav">'.$lang['Downloads'].'</a>',
		'NAV2' => '<a href="'.append_sid("search_downloads.$phpEx") . '" class="nav">'.$lang['Search'].' '.$lang['Downloads'].'</a>')
	);

	if ($total_found_dl == 0)
	{
		$template->assign_block_vars('no_searchresults', array(
			'L_NO_RESULTS' => $lang['No_search_match'])
		);
	}
	else
	{
		$sql = "SELECT d.*, c.cat_name, c.bbcode_uid as bbuid FROM ".DOWNLOADS_TABLE." d, ".DL_CAT_TABLE." c
			WHERE d.cat = c.id
				$sql_cat
				AND $sql_where
			ORDER BY sort $sort_dir
			LIMIT $start, " . $board_config['topics_per_page'];
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Could not read downloads data', '', __LINE__, __FILE__, $sql);
		}

		$i = 0;
		while ( $row = $db->sql_fetchrow($result) )
		{
			$cat_id = $row['cat'];
			$description = make_clickable(smilies_pass(bbencode_second_pass(stripslashes($row['description']), $row['bbcode_uid'])));
			$description = str_replace("\n", "\n<br />\n", $description);
			$file_name = $row['file_name'];
			$file_id = $row['id'];
			$description = '<a href="'.append_sid("dl_details.$phpEx?view=detail&amp;id=" . $file_id . "&amp;cat=" . $cat_id) . '" class="genmed">' . $description . '</a>';

			$file_free = $row['free'];
			$file_extern = $row['extern'];
			$file_size = $row['file_size'];
			$file_klicks = $row['klicks'];
			$file_traffic = $row['file_traffic'];

			$dl_status = array();
			$dl_status = get_dl_status($file_size, $file_extern, $file_id, $file_name, $file_free, $file_klicks, $file_traffic, $cat_id);

			$status = $dl_status['status'];
			$file_name = $dl_status['file_name'];

			$count_new = 0;
			$count_edit = 0;

			$mini_icon_new = $mini_icon_edit = '';

			for ($j = 0; $j < $total_downloads; $j++)
			{
				if ($row['new_edit'] == 1)
				{
					$count_new += (((time() - $row['change_time'])) / 86400 <= $board_config['dl_new_time'] && $board_config['dl_new_time'] > 0) ? 1 : 0;
				}

				if ($row['new_edit'] == 0)
				{
					$count_edit += (((time() - $row['change_time']) / 86400) <= $board_config['dl_edit_time'] && $board_config['dl_edit_time'] > 0) ? 1 : 0;
				}
			}

			if ($count_edit > 0)
			{
				$mini_icon_edit = '<img src="'.$images['icon_minipost'].'" border="0" />&nbsp;';
			}

			if ($count_new > 0)
			{
				$mini_icon_new = '<img src="'.$images['icon_minipost_new'].'" border="0" />&nbsp;';
			}

			$cat_bbcode_uid = $row['bbuid'];
			$cat_name = $row['cat_name'];
			$cat_name = ( $board_config['allow_html'] ) ? make_clickable($cat_name) : preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $cat_name);
			$cat_name = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($cat_name, $cat_bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $cat_name);
			$cat_name = ( $board_config['allow_smilies'] ) ? smilies_pass($cat_name) : $cat_name;
			$cat_name = '<a href="'.append_sid("downloads.$phpEx?cat=" . $cat_id) . '" class="genmed">' . $cat_name . '</a>';

			$long_desc = make_clickable(smilies_pass(bbencode_second_pass(stripslashes($row['long_desc']), $row['bbcode_uid'])));
			$long_desc = str_replace("\n", "\n<br />\n", $long_desc);

			$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

			$template->assign_block_vars('searchresults', array(
				'ROW_CLASS' => $row_class,
				'STATUS' => $status,
				"CAT_NAME" => $cat_name,
				'DESCRIPTION' => $mini_icon_new.$mini_icon_edit.'<b>'.$description.'</b>',
				'FILE_NAME' => $file_name,
				'LONG_DESC' => $long_desc)
			);
			$i++;
		}
	}

	$template->pparse('body');

	include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

	exit;
}

// Entry point of download searching
$sql = "SELECT id, cat_name, bbcode_uid as bbuid FROM " . DL_CAT_TABLE . "
	ORDER BY cat_name";
if (!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, 'Could not get categorie names', '', __LINE__, __FILE__, $sql);
}
while ($row = $db->sql_fetchrow($result))
{
	$cat_name = $row['cat_name'];
	$cat_bbcode_uid = $row['bbuid'];
	$cat_name = ( $board_config['allow_html'] ) ? make_clickable($cat_name) : preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $cat_name);
	$cat_name = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($cat_name, $cat_bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $cat_name);
	$cat_name = ( $board_config['allow_smilies'] ) ? smilies_pass($cat_name) : $cat_name;
}

$select_categories = '<select name="search_cat"><option value="-1">'.$lang['All'].'</option>';
$select_categories .= make_dl_jumpbox($cat);
$select_categories .= '</select>';

$s_sort_dir = '<select name="sort_dir">';
if($sort_dir == 'ASC')
{
	$s_sort_dir .= '<option value="ASC" selected="selected">' . $lang['Sort_Ascending'] . '</option><option value="DESC">' . $lang['Sort_Descending'] . '</option>';
}
else
{
	$s_sort_dir .= '<option value="ASC">' . $lang['Sort_Ascending'] . '</option><option value="DESC" selected="selected">' . $lang['Sort_Descending'] . '</option>';
}
$s_sort_dir .= '</select>';

$s_search_fields = '<select name="search_fields">';
for ($i = 0; $i < count($search_fields); $i++)
{
	$s_search_fields .= '<option value="'.$search_fields[$i].'">'.$search_fnames[$i].'</option>';
}
$s_search_fields .= '</select>';

$template->set_filenames(array(
	'body' => 'search_downloads_body.tpl')
);

$template->assign_vars(array(
	'L_SEARCH_QUERY' => $lang['Search'].' '.$lang['Downloads'],
	'L_SEARCH_OPTIONS' => $lang['Search_options'],
	'L_SEARCH_KEYWORDS' => $lang['Search_keywords'],
	'L_CATEGORY' => $lang['Category'],
	'L_SORT_BY' => $lang['Options'],
	'L_SORT_DIR' => $lang['Order'],
	'L_SEARCH' => $lang['Search'],

	'S_SEARCH_ACTION' => append_sid("search_downloads.$phpEx"),
	'S_CATEGORY_OPTIONS' => $select_categories,
	'S_SORT_ORDER' => $s_sort_dir,
	'S_SORT_OPTIONS' => $s_search_fields,
	'NAV1' => '<a href="'.append_sid("downloads.$phpEx") . '" class="nav">'.$lang['Downloads'].'</a>',
	'NAV2' => '<a href="'.append_sid("search_downloads.$phpEx") . '" class="nav">'.$lang['Search'].' '.$lang['Downloads'].'</a>')
);

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>